-- Delete all tables and types

SET ROLE mo_osmo;

DO $$ DECLARE
  r RECORD;
BEGIN
  FOR r IN (SELECT tablename FROM pg_tables WHERE tableowner=current_user) LOOP
    EXECUTE 'DROP TABLE ' || quote_ident(r.tablename) || ' CASCADE';
  END LOOP;

  FOR r IN (SELECT * FROM pg_type WHERE typcategory='E' AND typowner=(SELECT oid FROM pg_roles WHERE rolname=current_user)) LOOP
    EXECUTE 'DROP TYPE ' || quote_ident(r.typname);
  END LOOP;
END $$;
